#!/usr/bin/env python2.4
# -*- coding: UTF-8 -*-

import os,sys
from glob import glob
import ftplib

import time,string
from subprocess import Popen,PIPE
def run(cmds):
    p = Popen(cmds, shell=False,stdout=PIPE,stderr=PIPE)
    time.sleep(0.01)    # to avoid "IOError: [Errno 4] Interrupted system call"
    out = string.join(p.stdout.readlines() ).strip()
    outerr = string.join(p.stderr.readlines() ).strip()
    return out

def megarun(m):
    ligne = m.split("\n")
    for i in ligne:
        i=i.strip()
        if i:
            print ">>",i
            os.system(i)

class Make:
    USAGE ="""
unknown command ?!
---------------------------------------------------------
USAGE : %s <command>
commands are :
%s
---------------------------------------------------------"""
    __list={}

    @staticmethod
    def command(*a,**k):
        fct = a[0]
        Make.__list[ fct.__name__ ] = fct
        return fct

    @staticmethod
    def list():
        m=""
        for i in Make.__list.keys():
            m+= "- %-6s :%s \n" %(i,Make.__list[i].__doc__)
        return m

    @staticmethod
    def exists(nom):
        if nom in Make.__list:
            return Make.__list[nom]

    @staticmethod
    def main(argv):
        # ensure we are on the local path
        path = os.path.split(argv[0])[0]
        if path: os.chdir(path)

        cmd = len(argv)>1 and argv[1] or ""
        cb = Make.exists(cmd)
        if cb:
            cb()
        else:
            print Make.USAGE % (os.path.basename(argv[0]),Make.list())







VERSION = "0.2.%(rev)s"

DEST = "../packages/"
D_SOURCE = "sources/jbrout"
D_WIN32  = "win32/jbrout/App"
D_DEBIAN = "debian/data/usr/lib/jbrout"


@Make.command
#===============================================================================
def ver():
#===============================================================================
    """ get the version to version.txt """
    vfile = "version.txt"
    out = run(["svn","update"]).split(" ")
    rev = out[-1].replace(".","")
    version = VERSION % locals()
    open(vfile,"w").write( version )
    print "Version is ",version


@Make.command
#===============================================================================
def clean():
#===============================================================================
    """ clean the trunk (del *.pyc, ...)"""
    megarun("""
        find . -name "*.pyc" | xargs rm -fr
        find . -name "*.h" | xargs rm -fr""")



@Make.command
#===============================================================================
def app():
#===============================================================================
    """ make a source version  """
    ver()

    destSource = DEST+D_SOURCE

    cmds ="""
rm -rf %(destSource)s
mkdir %(destSource)s

cp -a gfx %(destSource)s
cp -a libs %(destSource)s
cp -a plugins %(destSource)s
cp -a tools %(destSource)s
cp -a po %(destSource)s
rm $dest$destSource/po/*.py

cp -a *.py %(destSource)s
cp -a jbrout.glade %(destSource)s
cp -a *.txt %(destSource)s
cp -a *.properties %(destSource)s

find %(destSource)s -name "*.pyc" | xargs rm -fr
find %(destSource)s -name "*.rej" | xargs rm -fr
find %(destSource)s -name "*.bak" | xargs rm -fr
find %(destSource)s -name "*.gladep" | xargs rm -fr
find %(destSource)s -name .svn | xargs rm -fr
find %(destSource)s -name "*~" | xargs rm -fr

svn log > %(destSource)s/changelog.txt
""" % locals()

    megarun(cmds)

@Make.command
#===============================================================================
def rmdist():
#===============================================================================
    """ delete packages """
    # delete the old packages
    pak=glob(DEST+"/jb*.gz")+\
        glob(DEST+"/binary/jb*.deb")+\
        glob(DEST+"/jb*.rpm")+\
        glob(DEST+"/jb*.zip")
    for i in pak:
        print "delete",i
        os.unlink(i)

@Make.command
#===============================================================================
def dist():
#===============================================================================
    """ make packaged version from source """
    version = open(DEST+D_SOURCE+"/version.txt").read().strip()

    cpath=os.getcwd()

    rmdist()

    # make the SOURCES tar.gz
    os.chdir(DEST+D_SOURCE+"/..")
    megarun("tar zcvf ../jbrout-%(version)s.sources.tar.gz jbrout" % locals())


    # make the win32 zip
    os.chdir(cpath)
    dest = DEST
    destSource=DEST+D_SOURCE
    destWin32 =DEST+D_WIN32
    megarun("""
        rm -rf %(destWin32)s
        mkdir %(destWin32)s
        cp -a %(destSource)s/* %(destWin32)s
        cp -a %(dest)swin32/jbrout/Lib/lxml/libxml2.dll %(destWin32)s
    """ % locals() )

    os.chdir(DEST+"win32")
    megarun("zip -r ../jbrout-%(version)s.win32.zip jbrout/*" % locals())

    # make the DEB
    os.chdir(cpath)
    destSource=DEST+D_SOURCE
    destDebian =DEST+D_DEBIAN
    megarun("""
        rm -rf %(destDebian)s
        cp -a %(destSource)s %(destDebian)s
        rm -rf %(destDebian)s/tools
        """ % locals())

    buf = open(DEST+"debian/control.txt").read()
    buf = buf.replace("-VERSION-",version)
    open(DEST+"debian/control/control","w").write(buf)

    os.chdir(DEST+"debian/data")
    megarun("""
    find . -type f |sed -e 's:^\./::' -e '/MD5SUMS/d' |sort |xargs md5sum >../control/md5sums
    """)

    os.chdir(cpath)
    os.chdir(DEST+"debian")
    megarun("""
        cd control; tar zcvf ../control.tar.gz .
        cd data; tar zcvf ../data.tar.gz .
        ar r ../jbrout-%(version)s.deb debian-binary control.tar.gz data.tar.gz
        rm *.tar.gz
        """ % locals() )

    # make the RPM
    os.chdir(cpath)
    os.chdir(DEST)

    megarun("""
        alien -r jbrout-%(version)s.deb
        mv jbrou*.rpm jbrout-%(version)s.noarch.rpm
        """ % locals())


    # make the DEB REPOSITORY
    os.chdir(cpath)
    os.chdir(DEST)

    megarun("""
        mv jbrout-%(version)s.deb binary
        dpkg-scanpackages binary /dev/null | gzip -9c > binary/Packages.gz
        """ % locals() )

@Make.command
#===============================================================================
def all():
#===============================================================================
    """ build a app, make packages and upload them (app+dist+upload)"""
    app()
    dist()
    upload()

@Make.command
#===============================================================================
def upload():
#===============================================================================
    """ upload all packages to the jbrout ftp"""
    version = open(DEST+D_SOURCE+"/version.txt").read().strip()

    s = ftplib.FTP('ftpperso.free.fr','jbrout','munster') # Connect

    file = DEST+"jbrout-"+version+".noarch.rpm"
    if os.path.isfile(file):
        print "upload",os.path.basename(file)
        s.cwd("download/rpm")
        f = open(file,'rb')
        s.storbinary('STOR '+os.path.basename(file), f)
        s.cwd("../..")

    file = DEST+"jbrout-"+version+".sources.tar.gz"
    if os.path.isfile(file):
        print "upload",os.path.basename(file)
        s.cwd("download/sources")
        f = open(file,'rb')
        s.storbinary('STOR '+os.path.basename(file), f)
        s.cwd("../..")

    file = DEST+"binary/jbrout-"+version+".deb"
    if os.path.isfile(file):
        s.cwd("download/debian/binary")

        print "upload",os.path.basename(file)
        f = open(file,'rb')
        s.storbinary('STOR '+os.path.basename(file), f)

        file = DEST+"binary/Packages.gz"
        print "upload",os.path.basename(file)
        f = open(file,'rb')
        s.storbinary('STOR '+os.path.basename(file), f)

        s.cwd("../../..")

    file = DEST+"jbrout-"+version+".win32.zip"
    if os.path.isfile(file):
        print "upload",os.path.basename(file)
        s.cwd("download/win32")
        f = open(file,'rb')
        s.storbinary('STOR '+os.path.basename(file), f)
        s.cwd("../..")

    s.quit()

if __name__=="__main__":
    Make.main(sys.argv)

