#!/usr/bin/env python
# -*- coding: UTF-8 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
# Python module plugins/redate/redate.py
# Autogenerated from redate.glade
# Generated on Tue Sep 27 21:59:02 2005

# Warning: Do not modify any context comment such as #--
# They are required to keep user's code

import os

import gtk

from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain

from datetime import datetime,timedelta

app_name = "plugin"
app_version = "0.0.1"

glade_dir = ""
locale_dir = "po"

bindtextdomain(app_name, locale_dir)


class Winredate(SimpleGladeApp):

    def __init__(self, path="redate.glade",
                 root="WinRedate",
                 domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    #-- Winredate.new {
    def new(self):
        self.main_widget.set_modal(True)
        self.main_widget.set_keep_above(True)
        self.main_widget.set_position(gtk.WIN_POS_CENTER)

        try:
            self.d = Winredate.defaultDate
        except:
            self.d = datetime.now() # just for self run
        self.recalc()
    #-- Winredate.new }

    #-- Winredate custom methods {
    def recalc(self):
        vw= self.weeks.get_value()
        vd= self.days.get_value()
        vh= self.hours.get_value()
        vi= self.minutes.get_value()
        vs= self.seconds.get_value()

        f = lambda x: x.strftime( unicode(_("%m/%d/%Y %H:%M:%S")).encode("utf_8") )

        dn=self.d
        dn+=timedelta(weeks=vw, days=vd,hours=vh,minutes=vi,seconds=vs)

        msg = _("Example date : %s \n\n\n") % f(self.d)
        if vw == vd == vh == vi == vs == 0:
            self.vals = None
            msg += _("No change")
        else:
            self.vals = (vw,vd,vh,vi,vs)
            msg += _("Change to %s :\n\n") % f(dn)
        self.msg.set_text(msg)
    #-- Winredate custom methods }

    #-- Winredate.on_WinRedate_delete_event {
    def on_WinRedate_delete_event(self, widget, *args):
        self.reponse=False
        gtk.main_quit()
    #-- Winredate.on_WinRedate_delete_event }

    #-- Winredate.on_weeks_value_changed {
    def on_weeks_value_changed(self, widget, *args):
        self.recalc()
    #-- Winredate.on_weeks_value_changed }

    #-- Winredate.on_days_value_changed {
    def on_days_value_changed(self, widget, *args):
        self.recalc()
    #-- Winredate.on_days_value_changed }

    #-- Winredate.on_hours_value_changed {
    def on_hours_value_changed(self, widget, *args):
        self.recalc()
    #-- Winredate.on_hours_value_changed }

    #-- Winredate.on_minutes_value_changed {
    def on_minutes_value_changed(self, widget, *args):
        self.recalc()
    #-- Winredate.on_minutes_value_changed }

    #-- Winredate.on_seconds_value_changed {
    def on_seconds_value_changed(self, widget, *args):
        self.recalc()
    #-- Winredate.on_seconds_value_changed }

    #-- Winredate.on_btn_annuler_clicked {
    def on_btn_annuler_clicked(self, widget, *args):
        self.reponse=False
        self.main_widget.destroy()
        gtk.main_quit()
    #-- Winredate.on_btn_annuler_clicked }

    #-- Winredate.on_btn_appliquer_clicked {
    def on_btn_appliquer_clicked(self, widget, *args):
        self.reponse=self.vals
        self.main_widget.destroy()
        gtk.main_quit()
    #-- Winredate.on_btn_appliquer_clicked }


#-- main {

def main():
    win_redate = Winredate()

    win_redate.run()

if __name__ == "__main__":
    main()

#-- main }
