#!/usr/bin/env python
# -*- coding: utf-8 -*-
import os,sys,stat


def walktree (top = ".", depthfirst = True):
    names = os.listdir(top)
    if not depthfirst:
        yield top, names
    for name in names:
        try:
            st = os.lstat(os.path.join(top, name))
        except os.error:
            continue
        if stat.S_ISDIR(st.st_mode):
            for (newtop, children) in walktree (os.path.join(top, name), depthfirst):
                yield newtop, children
    if depthfirst:
        yield top, names

if __name__ == "__main__":
    # extract all strings from glade files (in ./tmp)
    # and build a list of them
    path = ".."
    list = []
    for (basepath, children) in walktree(path,False):
        for child in children:
            if child.split(".")[-1] == "glade":
                f=os.path.join(basepath, child).decode( sys.getfilesystemencoding() )
                if "/plugins/" not in f:
                    list.append( f )

    h=[]
    for i in list:
        os.system('intltool-extract -l --type=gettext/glade %s'%i)
        h.append("po/tmp/"+os.path.basename(i)+".h")

    # build a POTFILES.in with py files and glade.h files
    list = []
    for (basepath, children) in walktree(path,False):
        for child in children:
            if child.split(".")[-1] == "py":
                f=os.path.join(basepath, child).decode( sys.getfilesystemencoding() )
                if "/plugins/" not in f:
                    f=f.replace("../","")
                    list.append( f )

    open("POTFILES.in","w").write("\n".join(["[encoding: UTF-8]"]+list+h+[""]))

    # and update pot files with potfiles
    os.system("intltool-update --pot --gettext-package=jbrout")

    # delete the tmp of glade.h files
    os.system("rm -rf tmp")

    # delete the POTFILES
    os.system("rm POTFILES.in")

    # and merge all existing po from pot
    # and compile po -> mo
    path="."
    list = []
    for (basepath, children) in walktree(path,False):
        for child in children:
            if child.split(".")[-1] == "po":
                f=os.path.join(basepath, child).decode( sys.getfilesystemencoding() )
                list.append( f )
    for i in list:
        os.system('msgmerge -q -U %s jbrout.pot' % i)
        f=i[:-3]
        os.system("msgfmt %s.po -o %s.mo" % (f,f))
        os.system('msgfmt --statistics %s' % i)
        os.system("rm messages.mo")
