#!/usr/bin/env python
# -*- coding: utf-8 -*-
import os,sys,stat


def walktree (top = ".", depthfirst = True):
    names = os.listdir(top)
    if not depthfirst:
        yield top, names
    for name in names:
        try:
            st = os.lstat(os.path.join(top, name))
        except os.error:
            continue
        if stat.S_ISDIR(st.st_mode):
            for (newtop, children) in walktree (os.path.join(top, name), depthfirst):
                yield newtop, children
    if depthfirst:
        yield top, names

if __name__ == "__main__":
    # extract all strings from glade files (in ./tmp)
    # and build a list of them
    path = "../plugins"
    plugins = [path+"/"+i for i in os.listdir(path) if i[0]!="." and os.path.isdir(path+"/"+i)]

    for path in plugins:
        print "plugins '%s'" % path
        list = []
        for (basepath, children) in walktree(path,False):
            for child in children:
                if child.split(".")[-1] == "glade":
                    list.append( os.path.join(basepath, child).decode( sys.getfilesystemencoding() ) )
        h=[]
        for i in list:
            os.system('intltool-extract -l --type=gettext/glade %s'%i)
            h.append("po/tmp/"+os.path.basename(i)+".h")

        # build a POTFILES.in with py files and glade.h files
        list = []
        for (basepath, children) in walktree(path,False):
            for child in children:
                if child.split(".")[-1] == "py":
                    f=os.path.join(basepath, child).decode( sys.getfilesystemencoding() )
                    f=f.replace("../","")
                    list.append( f )

        open("POTFILES.in","w").write("\n".join(["[encoding: UTF-8]"]+list+h+[""]))

        # and update pot files with potfiles
        os.system("intltool-update --pot --gettext-package=plugin")

        # delete the tmp of glade.h files
        os.system("rm -rf tmp")

        # delete the POTFILES
        os.system("rm POTFILES.in")

        poDir=os.path.join(path,"po")
        if not os.path.isdir(poDir):
            os.mkdir(poDir)
        os.rename("plugin.pot",poDir+"/plugin.pot")

        # and merge all existing po from pot
        # and compile po -> mo
        path=poDir
        list = []
        for (basepath, children) in walktree(path,False):
            for child in children:
                if child.split(".")[-1] == "po":
                    f=os.path.join(basepath, child).decode( sys.getfilesystemencoding() )
                    list.append( f )
        for i in list:
            os.system('msgmerge -q -U %s %s/plugin.pot' % (i,poDir))
            f=i[:-3]
            os.system("msgfmt %s.po -o %s.mo" % (f,f))
            os.system('msgfmt --statistics %s' % i)
            os.system("rm messages.mo")
